/////////////////////////////////////////////////////////////////////////////
// $Id: DoSoftSharp.inc,v 1.0 2002/06/27 17:18:54 trbarry Exp $
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2002 Tom Barry  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
//
//  Also, this program is "Philanthropy-Ware".  That is, if you like it and 
//  feel the need to reward or inspire the author then please feel free (but
//  not obligated) to consider joining or donating to the Electronic Frontier
//  Foundation. This will help keep cyber space free of barbed wire and bullsh*t.  
//  See www.eff.org for details
/////////////////////////////////////////////////////////////////////////////
// CVS Log
//
// $Log: DoSoftSharp.inc,v $
//
/////////////////////////////////////////////////////////////////////////////

// This include stmt is the low level code loop that actually does the soften/sharpen

    const __int64 YMask		= 0x00ff00ff00ff00ff;	// to keep only luma
    const __int64 UVMask    = 0xff00ff00ff00ff00;	// to keep only chroma
	int ct = (rowsize / 8) - 2;

//esi src line
//edi dst
//eax src pitch
//ebx src - 2 lines
//ecx count
//edx 
	_asm
	{
		mov		ebx, Source					// the source line
		mov		edi, Dest					// new output line dest
		movq	mm0, qword ptr[ebx]			// get first 8 bytes
		movq	qword ptr[edi], mm0			// don't sharpen first qword
		mov		eax, rowsize				// past end of row
		movq	mm0, qword ptr[ebx+eax-8]	// get last qword in row
		movq	qword ptr[edi+eax-8], mm0	// don't sharpen (some of) last qword
        mov     eax, src_pitch
		sub		ebx, eax					// always point at top of 3 or 5 lines
		add		ebx, 8						// skip first qword for now
		add		edi, 8						// skip first qword for now
		mov		ecx, ct
        movq    mm6, UVMask                 // useful constant
        movq    mm7, YMask                  // useful constant
        cmp     word ptr[QVC],0              // was 3rd parm 0?
        je      cloopEasy                   // yes, do faster way, don't access as much mem

		sub		ebx, eax					// point at top of 5 lines

		align	16
cloop:	
		lea		esi, [ebx+2*eax]			// point at the real line
        movq    mm2, qword ptr[ebx]			// Zi
        movq    mm1, qword ptr[ebx+eax]     // Zj
		movq	mm0, qword ptr[esi]		    // Zk 
		movq	mm3, qword ptr[esi-2]		// Zj (horiz)
		movq	mm4, qword ptr[esi-4]		// Zi (horiz)

//      pavgb   mm1, qword ptr[esi+eax] 	// avg(Zj,Zl)
		V_PAVGB(mm1, qword ptr[esi+eax], mm5, ShiftMask)

//      pavgb   mm2, qword ptr[esi+2*eax]   // avg(Zi,Zm)
		V_PAVGB(mm2, qword ptr[esi+2*eax], mm5, ShiftMask)

//        pavgb   mm3, qword ptr[esi+2] 		// avg(Zj,Zl) horiz
  		V_PAVGB(mm3, qword ptr[esi+2], mm5, ShiftMask)

//      pavgb   mm4, qword ptr[esi+4]		// avg(Zi,Zm) horiz
  		V_PAVGB(mm4, qword ptr[esi+4], mm5, ShiftMask)

        movq    mm5, mm0                    // save copy of center line, Zk with chroma

// calc horizontal
        pand    mm0, mm7					// only luma
		pmullw  mm0, QHA                    // mult by weighting factor, HA * Zk  

        pand    mm3, mm7					// only luma
		pmullw  mm3, QHB                    // mult by weighting factor, HB * avg(Zj, Zl)
        
        pand    mm4, mm7
		pmullw  mm4, QHC                    // mult by HC weighting factor

#ifdef REALLY_HORIZ_SOFTNESS
        paddusw mm0, mm3                    // add in weighted average of Zj,Zl 
        paddusw mm0, mm4                    // sub weighted average of Zj,Zl 
#else
        psubusw mm3, mm4                    // add in weighted average of Zj,Zl 
        psubusw mm0, mm3                    // sub weighted average of Zj,Zl 
#endif
        psrlw   mm0, 6					    // should be our horiz luma answers

#ifdef IS_MMX
		movq	mm3, mm0
		pcmpgtb mm3, mm7					// did we overflow into chroma bytes (ff=yes, else 00's)
		psrlw   mm3, 8						// shift ff or 00 into luma pos
		por		mm0, mm3					// maybe set luma's to ff
		pand	mm0, mm7					// either way clear chroma again		
#else
        pminsw  mm0, mm7                    // avoid overflow
#endif

// calc vertical
		pmullw  mm0, QVA                    // mult by weighting factor, VA * Zk  

        pand    mm1, mm7
		pmullw  mm1, QVB                    // mult by weighting factor, VB * avg(Zj, Zl)
        
        pand    mm2, mm7
		pmullw  mm2, QVC                    // mult by weighting factor

#ifdef REALLY_VERT_SOFTNESS
        paddusw mm0, mm2                    // add in weighted average of Zj,Zl 
        paddusw mm0, mm1                    // sub weighted average of Zj,Zl 
#else
        psubusw mm1, mm2                    // add in weighted average of Zj,Zl 
        psubusw mm0, mm1                    // sub weighted average of Zj,Zl 
#endif
        psrlw   mm0, 6					    // should be our luma answers

#ifdef IS_MMX
		movq	mm3, mm0
		pcmpgtb mm3, mm7					// did we overflow into chroma bytes (ff=yes, else 00's)
		psrlw   mm3, 8						// shift ff or 00 into luma pos
		por		mm0, mm3					// maybe set luma's to ff
		pand	mm0, mm7					// either way clear chroma again		
#else
        pminsw  mm0, mm7                    // avoid overflow
#endif

        pand    mm5, mm6                    // get chroma from here
        por     mm0, mm5                    // put chroma back, add 1*luma

//        movntq	qword ptr[edi], mm0
		V_MOVNTQ(qword ptr[edi], mm0) 

		lea   	ebx, [ebx+8]
		lea		edi, [edi+8]

#ifdef IS_MMX
		dec		ecx							// stupid MMX macros made it too fat for loop instruct
		jz		done
		jmp		cloop
#else
		loop	cloop						// go do next 4 pixels
        jmp     done
#endif

// here we do a faster way since QVC = 0 and we don't have to access as much memory
		align	16
cloopEasy:                                  // easy way only 2 vals	
        movq    mm3, qword ptr[ebx+eax-2]   // Zj (horiz)
		movq	mm4, qword ptr[ebx+eax-4]	// Zi (horiz)
        movq    mm1, qword ptr[ebx]		    // Zj

//      pavgb   mm3, qword ptr[ebx+eax+2]	// avg(Zj,Zl) (horiz)
		V_PAVGB (mm3, qword ptr[ebx+eax+2], mm5, ShiftMask)

//      pavgb   mm4, qword ptr[ebx+eax+4]		// avg(Zi,Zm) horiz
  		V_PAVGB (mm4, qword ptr[ebx+eax+4], mm5, ShiftMask)


		movq	mm0, qword ptr[ebx+eax]     // Zk 

//      pavgb   mm1, qword ptr[ebx+2*eax]	// avg(Zj,Zl)
		V_PAVGB (mm1, qword ptr[ebx+2*eax], mm5, ShiftMask)

        movq    mm5, mm0                    // save copy of center line, Zk with chroma

// calc horizontal

        pand    mm0, mm7					// only luma
		pmullw  mm0, QHA                    // mult by weighting factor, HA * Zk  

        pand    mm3, mm7
		pmullw  mm3, QHB                    // mult by weighting factor, HB * avg(Zj, Zl)

        pand    mm4, mm7
		pmullw  mm4, QHC                    // mult by HC weighting factor

#ifdef REALLY_HORIZ_SOFTNESS    
        paddusw mm0, mm3                    // add weighted average of Zj,Zl 
        paddusw mm0, mm4                    // sub weighted average of Zj,Zl 
#else
        psubusw mm3, mm4                    // add in weighted average of Zj,Zl 
        psubusw mm0, mm3                    // sub weighted average of Zj,Zl 
#endif

        psrlw   mm0, 6					    // should be our luma answers
#ifdef IS_MMX
		movq	mm3, mm0
		pcmpgtb mm3, mm7					// did we overflow into chroma bytes (ff=yes, else 00's)
		psrlw   mm3, 8						// shift ff or 00 into luma pos
		por		mm0, mm3					// maybe set luma's to ff
		pand	mm0, mm7					// either way clear chroma again		
#else
        pminsw  mm0, mm7                    // avoid overflow
#endif

// calc vertical

		pmullw  mm0, QVA                    // mult by weighting factor, VA * Zk  

        pand    mm1, mm7
		pmullw  mm1, QVB                    // mult by weighting factor, VB * avg(Zj, Zl)

#ifdef REALLY_VERT_SOFTNESS    
        paddusw mm0, mm1                    // add weighted average of Zj,Zl 
#else
        psubusw mm0, mm1                    // sub weighted average of Zj,Zl 
#endif

        psrlw   mm0, 6					    // should be our luma answers
        pminsw  mm0, mm7					// avoid overflow
        pand    mm5, mm6	              // get chroma from here
        por     mm0, mm5                    // put chroma back, add 1*luma

        movntq	qword ptr[edi], mm0
		lea   	ebx, [ebx+8]
		lea		edi, [edi+8]

#ifdef IS_MMX
		dec		ecx							// stupid MMX macros made it too fat for loop instruct
		jz		done
		jmp		cloopEasy
#else
		loop	cloopEasy					// go do next 4 pixels
#endif

done:

#ifndef IS_MMX
        sfence
#endif

	}
	return 0;
